require "MLMachine/version"

module MLMachine
  class Error < StandardError; end
  
  class StateMachine
    def self.translate
      number = File.read("data/input/number.txt").strip.to_i
      input  = File.read("data/input/input.txt")

      active_input = input[number].downcase.split(" ")

      translate = {
        'ruh'                             =>     "the-masculine",
        'rah'                             =>      "the-feminine",
        'roh'                             =>        "the-neuter",
        'yona'                            =>                 "a",
        'yonei'                           =>                "an",
        'yonas'                           =>          "a-neuter",
        'eneru'                           =>             "black",
        'berena'                          =>             "white",
        'erudi'                           =>               "red",
        'eviyette'                        =>            "purple",
        'beru'                            =>               "red",
        'evene'                           =>             "green",
        'yeru'                            =>            "yellow",
        'eranige'                         =>            "orange",
        'enesu'                           =>             "North",
        'wesi'                            =>              "West",
        'easi'                            =>              "East",
        'siuha'                           =>             "South",
        'upe'                             =>                "up",
        'dio'                             =>              "down",
        'feru'                            =>           "dorward",
        'biosi'                           =>          "backward",
        'iniwa'                           =>            "inward",
        'utiwa'                           =>           "outward",
        'esakeru'                         =>          "sneakers",
        'deruesu'                         =>       "dress-shoes",
        'eheru'                           =>             "heels",
        'siabi'                           =>             "clogs",
        'siabi-biesa'                     =>      "wooden-clogs",
        'berukiesiti'                     =>      "birkenstocks",
        'esiadi'                          =>           "sandals",
        'tero'                            =>          "trousers",
        'sikeru'                          =>             "skirt",
        'deresi'                          =>             "dress",
        'sehiere'                         =>             "shirt",
        'sioki'                           =>          "stocking",
        'sitaka'                          =>             "socks",
        'sitaki'                          =>             "steak",
        'siho-sitaki'                     =>        "chop-steak",
        'befi'                            =>              "beef",
        'shikini'                         =>           "chicken",
        'tieru'                           =>            "turkey",
        'liam'                            =>              "lamb",
        'ehaki'                           =>               "elk",
        'deru'                            =>              "deer",
        'pirosi'                          =>              "porc",
        'bieru'                           =>              "bear",
        'siaro'                           =>            "carrot",
        'pitat'                           =>            "potato",
        'siaba'                           =>           "cabbage",
        'sipinas'                         =>           "spinach",
        'eretuce'                         =>           "lettuce",
        'siwa-pitat'                      =>      "sweet-potato",
        'ginie'                           =>            "ginger",
        'siquasi'                         =>            "squash",
        'piemaki'                         =>           "pumpkin",
        'tea'                             =>               "tea",
        'siofee'                          =>            "coffee",
        'eribos'                          =>             "herbs",
        'givimio'                         =>           'give-me',
        'ehieru'                          =>              'hour',
        'vieruti'                         =>            'vortex',
        'perumipito'                      =>          'promptor',
        'esipier'                         =>            'cipher',
        'digisi-esitimi'                  =>   'digest estimate',
        'ehypier-sierusutio'              => 'hyper-calculation',
      }

      word_01 = translate[active_input[0]]
      word_02 = translate[active_input[1]]
      word_03 = translate[active_input[2]]
      word_04 = translate[active_input[3]]
      word_05 = translate[active_input[4]]
      word_06 = translate[active_input[5]]
      word_07 = translate[active_input[6]]
      word_08 = translate[active_input[7]]
      word_09 = translate[active_input[8]]
      word_10 = translate[active_input[9]]

      translated = "Translated: #{word_01} #{word_02} #{word_03} #{word_04} #{word_05} #{word_06} #{word_07} #{word_08} #{word_09} #{word_10}"

      open("output/translator/translation.txt", "w") { |f|
        f.puts translated
      }
    end

    def self.classify
      def self.download_data
        system("cd data/baysian; w3m /home/sarah/public_sync/downloads/shared_dataset/language.nb")
      end

      def self.naive_bayes
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/language.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        word_one = a.classify(*b[0])
        word_two = a.classify(*b[1])
        word_tre = a.classify(*b[2])
        word_fro = a.classify(*b[3])
        word_fiv = a.classify(*b[4])
        word_six = a.classify(*b[5])
        word_sev = a.classify(*b[6])

        ## Labels
        first_label  = word_one[0]
        second_label = word_two[0]
        third_label  = word_tre[0]
        fourth_label = word_fro[0]
        fifth_label  = word_fiv[0]
        sixth_label  = word_six[0]
        seven_label  = word_sev[0]

        ## Probabilities
        first_prob  = word_one[1]
        second_prob = word_two[1]
        third_prob  = word_tre[1]
        fourth_prob = word_fro[1]
        fifth_prob  = word_fiv[1]
        sixth_prob  = word_six[1]
        seven_prob  = word_sev[1]

        open("output/baysian/labels.txt", "w") { |f|
          f.puts "  Labels:\n  #{first_label}\n  #{second_label}\n  #{third_label}\n  #{fourth_label}\n  #{fifth_label}\n  #{sixth_label}\n  #{seventh_label}"
        }

        open("output/baysian/probabilities.txt", "w") { |f|
          f.puts "  Probabilities:\n  #{first_prob}\n  #{second_prob}\n  #{third_prob}\n  #{fourth_prob}\n  #{fifth_prob}\n  #{sixth_prob}\n  #{seventh_prob}"
        }

        puts "  Labels:\n  #{first_label}\n  #{second_label}\n  #{third_label}\n  #{fourth_label}\n  #{fifth_label}\n  #{sixth_label}\n  #{seventh_label}\n"
        puts "  Probabilities:\n  #{first_prob}\n  #{second_prob}\n  #{third_prob}\n  #{fourth_prob}\n  #{fifth_prob}\n  #{sixth_prob}\n  #{seventh_prob}\n\n"
      end

      def self.remove_data
        system("cd data/baysian; shred --remove language.nb")
      end

      MLMachine::StateMachine.classify.download_data
      MLMachine::StateMachine.classify.naive_bayes
      MLMachine::StateMachine.classify.remove_data
    end

    def self.ruleset
      def self.download_data; system("git clone http://localhost:3000/LWFlouisa/evo_data.git"); end

      def self.line;   require "rules_ai"; RulesAi::Rules_Set.line;   end
      def self.square; require "rules_ai"; RulesAi::Rules_Set.square; end
      def self.cube;   require "rules_ai"; RulesAi::Rules_Set.cube;   end
      def self.hyper;  require "rules_ai"; RulesAi::Rules_Set.hyper;  end

      def self.hours_passed;         require "rules_ai"; RulesAi::Rules_Set.hours_passed;         end
      def self.tesla_multiplication; require "rules_ai"; RulesAi::Rules_Set.tesla_multiplication; end
      def self.autonomous_prompting; require "rules_ai"; RulesAi::Rules_Set.autonomous_prompting; end
      def self.mixed_13;             require "rules_ai"; RulesAi::Rules_Set.mixed_13;             end
      def self.estimate_digest;      require "rules_ai"; RulesAi::Rules_Set.estimate_digest;      end
      def self.caculate_hyper;       require "rules_ai"; RulesAi::Rules_Set.caculate_hyper;       end

      ## Fitness Function
      def self.reset_evo
        # Gets the bot shape.
        bot_shape = File.readlines("evo_data/bot_shape/wings.txt")

        # Create a new input vector based on bot data size.
        bot_input = bot_shape.size.to_i

        # Reset user input to zero.
        reset_usr_input = 0

        open("evo_data/number/input.txt", "w") { |f|
          f.puts reset_usr_input
        }

        # Get random bot_input from bot reset.
        bot_reset = rand(bot_input)

        open("evo_data/bot_input/input.txt", "w") { |f|
          f.puts bot_reset
        }
      end

      def self.use_form
        model_type = File.read("evo_data/model/model_type.txt").strip

        puts 'Form status: Suitable...'

        sleep(3)

        number           = File.read("evo_data/number/input.txt").strip.to_i
        usr_wings        = File.readlines("evo_data/usr_shape/wings.txt")
        current_wingset  = usr_wings[number].strip

        puts "\nModel Type: #{model_type}\nAction: #{current_wingset}\n"

        sleep(3)

        if    current_wingset ==         "hours_passed";         MLMachine::StateMachine.ruleset.hours_passed;
        elsif current_wingset == "tesla_multiplication"; MLMachine::StateMachine.ruleset.tesla_multiplication;
        elsif current_wingset == "autonomous_prompting"; MLMachine::StateMachine.ruleset.autonomous_prompting;
        elsif current_wingset ==             "mixed_13";             MLMachine::StateMachine.reset_evo.mixed_13;
        elsif current_wingset ==      "estimate_digest";      MLMachine::StateMachine.ruleset.estimate_digest;
        elsif current_wingset ==      "calculate_hyper";      MLMachine::StateMachine.ruleset.calculate_hyper;
        elsif current_wingset ==                 "line";                 MLMachine::StateMachine.ruleset.line;
        elsif current_wingset ==               "square";               MLMachine::StateMachine.ruleset.square;
        elsif current_wingset ==                 "cube";                 MLMachine::StateMachine.ruleset.cube;
        elsif current_wingset ==                "hyper";                MLMachine::StateMachine.ruleset.hyper;
        end

        MLMachine::StateMachine.ruleset.reset_evo

        abort
      end

      def self.reshape
        system("clear")

        model_type = File.read("evo_data/model/model_type.txt").strip

        bot_choice = File.read("evo_data/bot_input/input.txt").strip.to_i
        number     = File.read("evo_data/number/input.txt").strip.to_i

        usr_wings = File.readlines("evo_data/usr_shape/wings.txt")
        bot_wings = File.readlines("evo_data/bot_shape/wings.txt")

        current_wingset  = usr_wings[number]
        current_botwings = bot_wings[bot_choice]

        puts "The user #{model_type} model is: #{current_wingset}"
        puts "The bot #{model_type} model is: #{current_botwings}"

        if current_wingset == current_botwings
          MLMachine::StateMachine.ruleset.use_form
        else
          puts "Form status: Changing form..."

          sleep(3)

          new_value = number + 1

          open("evo_data/number/input.txt", "w") { |f|
            f.puts new_value
          }
        end

        MLMachine::StateMachine.ruleset.reset_reshape
      end

      MLMachine::StateMachine.ruleset.download_data
      MLMachine::StateMachine.ruleset.reset_evo
      MLMachine::StateMachine.ruleset.reshape
    end

    def self.crunch_labels
      require "finite_machine"

      number = File.read("data/ml_machine/state_machine/input.txt").strip.to_i

      ai_functions = [
        "ai.init",     "ai.translate", "ai.classify",
        "ai.analyses", "ai.rules_ai"
      ]

      ai = FiniteMachine.new do

        # None turns off the state machine.
        event :init,      :none => :translation
        event :translate, :translation    => :classification
        event :classify,  :classification => :analyze_data
        event :analyses,  :analyze_data   => :ruleset
        event :rules_ai,  :ruleset        => :none

        # What each event does.
        on_enter(:translate) { |event|
          MLMachine::StateMachine.translate
        }

        on_enter(:classify) { |event|
          MLMachine::StateMachine.classify
        }

        on_enter(:analyses) { |event|
          MLMachine::StateMachine.analyses
        }

        on_enter(:rules_ai) { |event|
          MLMachine::StateMachine.ruleset
        }
      end

      choose_routine = ai_function[number].to_s
    end
  end
end
